﻿// ProofDll.cpp : 定义 DLL 的导出函数。
//

#include "pch.h"
//#include "framework.h"
#include "ProofDll.h"
#include "Aes.h"

#include <string>
#include <map>
using namespace std;

typedef map<wstring, UINT> UINT_MAP;
typedef map<wstring, BOOL> BOOL_MAP;
typedef map<wstring, wstring> STRING_MAP;
typedef map<wstring, CHAR_BUFFER> BUFFER_MAP;

UINT_MAP gUintMap;
BOOL_MAP gBoolMap;
STRING_MAP gStringMap;
BUFFER_MAP gBufferMap;
int gErrCode=0;

unsigned char gAesKey[32] = {
		0xfd,0xc2,0x9d,0x92,0xd5,0xb9,0xbc,0xc6,
		0xe2,0x67,0x94,0x61,0x99,0xaf,0x23,0xb3,
		0xed,0xde,0x94,0x83,0x62,0x46,0xc9,0x93,
		0x78,0xa4,0xef,0x15,0x16,0xcc,0x9e,0x12
};
enum MAP_TYPE
{
	MAP_UINT=0,
	MAP_BOOL,
	MAP_BUFFER,
	MAP_STRING
};
enum ERR_CODE
{
	ERR_LOST_PLAINTEXT = 1,
	ERR_LOST_CIPHERTEXT,
	ERR_LOST_AESKEY,
	ERR_BUFFER_NOT_ENOUGH
};
bool existKey(MAP_TYPE type, wstring strKey)
{
	bool ret=false;
	UINT_MAP::iterator uint_iter;
	BOOL_MAP::iterator bool_iter;
	STRING_MAP::iterator string_iter;
	BUFFER_MAP::iterator buffer_iter;

	switch (type)
	{
	case MAP_UINT:
		uint_iter = gUintMap.find(strKey);
		if (uint_iter != gUintMap.end())
			ret = true;
		break;
	case MAP_BOOL:
		bool_iter = gBoolMap.find(strKey);
		if (bool_iter != gBoolMap.end())
			ret = true;
		break;
	case MAP_BUFFER:
		buffer_iter = gBufferMap.find(strKey);
		if (buffer_iter != gBufferMap.end())
			ret = true;
		break;
	case MAP_STRING:
		string_iter = gStringMap.find(strKey);
		if (string_iter != gStringMap.end())
			ret = true;
		break;
	default:
		break;
	}
	return ret;
}
void doAesECBEncrypt(LPBYTE out)
{
	wstring strKey;
	int rdsz;
	UINT uiPlainSize;
	LPBYTE plainBuffer,encryptBuffer;
	AesCtx context;

	strKey = L"AESKEY";
	if (!existKey(MAP_BUFFER, strKey))
		AesSetKey(&context, AES_KEY_256BIT, BLOCKMODE_ECB, gAesKey, NULL);
	else
	{
		AesSetKey(&context, AES_KEY_256BIT, BLOCKMODE_ECB, gBufferMap[strKey].buffer, NULL);
	}
	strKey = L"PLAINTEXT";
	plainBuffer = (LPBYTE)gBufferMap[strKey].buffer;
	uiPlainSize = gBufferMap[strKey].size;
	encryptBuffer = out;

	while (uiPlainSize > 0)
	{
		if (uiPlainSize >= 4096)
		{
			rdsz = 4096;
		}
		else
			rdsz = uiPlainSize;
		AesEncryptECB(&context, encryptBuffer, plainBuffer, rdsz);
		plainBuffer += rdsz;
		encryptBuffer += rdsz;
		uiPlainSize -= rdsz;
	}
}
void doAesECBDecrypt(LPBYTE out)
{
	wstring strKey;
	int rdsz;
	UINT uiCipherSize;
	LPBYTE cipherBuffer, plainBuffer;
	AesCtx context;

	strKey = L"AESKEY";
	if (!existKey(MAP_BUFFER, strKey))
		AesSetKey(&context, AES_KEY_256BIT, BLOCKMODE_ECB, gAesKey, NULL);
	else
	{
		AesSetKey(&context, AES_KEY_256BIT, BLOCKMODE_ECB, gBufferMap[strKey].buffer, NULL);
	}
	strKey = L"CIPHERTEXT";
	cipherBuffer = (LPBYTE)gBufferMap[strKey].buffer;
	uiCipherSize = gBufferMap[strKey].size;
	plainBuffer = out;

	while (uiCipherSize > 0)
	{
		if (uiCipherSize >= 4096)
		{
			rdsz = 4096;
		}
		else
			rdsz = uiCipherSize;
		AesDecryptECB(&context, plainBuffer, cipherBuffer, rdsz);
		plainBuffer += rdsz;
		cipherBuffer += rdsz;
		uiCipherSize -= rdsz;
	}
}
UINT getProofLevel()
{
	return PROOF_BASIC | PROOF_MIDDLE | PROOF_HIGH;
}
void addUintParam(LPCWSTR strKey, UINT value)
{
	gUintMap[strKey] = value;
}
void addBoolParam(LPCWSTR strKey, BOOL value)
{
	gBoolMap[strKey] = value;
}
void addBufferParam(LPCWSTR strKey, CHAR_BUFFER value)
{
	gBufferMap[strKey] = value;
}
void addStringParam(LPCWSTR strKey, LPCWSTR value)
{
	gStringMap[strKey] = value;
}
int getErrorCode()
{
	return gErrCode;
}
BOOL doBasicEncrypt(CHAR_BUFFER outBuffer)
{
	wstring strKey;
	strKey = L"PLAINTEXT";
	if (!existKey(MAP_BUFFER, strKey))
	{
		gErrCode = ERR_LOST_PLAINTEXT;
		return FALSE;
	}
	if (outBuffer.size < gBufferMap[strKey].size) {
		gErrCode = ERR_BUFFER_NOT_ENOUGH;
		return FALSE;
	}
	 
	doAesECBEncrypt((LPBYTE)outBuffer.buffer);
	
	return TRUE;
}
BOOL doMiddleEncrypt(CHAR_BUFFER outBuffer)
{
	wstring strKey;
	strKey = L"PLAINTEXT";
	if (!existKey(MAP_BUFFER, strKey))
	{
		gErrCode = ERR_LOST_PLAINTEXT;
		return FALSE;
	}
	if (outBuffer.size < gBufferMap[strKey].size) {
		gErrCode = ERR_BUFFER_NOT_ENOUGH;
		return FALSE;
	}
	memcpy(outBuffer.buffer, gBufferMap[strKey].buffer, gBufferMap[strKey].size);
	outBuffer.size = gBufferMap[strKey].size;
	//doAesECBEncrypt((LPBYTE)outBuffer.buffer);

	return TRUE;
}
BOOL doHighEncrypt(CHAR_BUFFER outBuffer)
{
	/*wstring strKey;
	strKey = L"PLAINTEXT";
	if (!existKey(MAP_BUFFER, strKey))
	{
		gErrCode = ERR_LOST_PLAINTEXT;
		return FALSE;
	}
	if (outBuffer.size < gBufferMap[strKey].size) {
		gErrCode = ERR_BUFFER_NOT_ENOUGH;
		return FALSE;
	}

	doAesECBEncrypt((LPBYTE)outBuffer.buffer);*/

	return TRUE;
}
