﻿// 下列 ifdef 块是创建使从 DLL 导出更简单的
// 宏的标准方法。此 DLL 中的所有文件都是用命令行上定义的 PROOFDLL_EXPORTS
// 符号编译的。在使用此 DLL 的
// 任何项目上不应定义此符号。这样，源文件中包含此文件的任何其他项目都会将
// PROOFDLL_API 函数视为是从 DLL 导入的，而此 DLL 则将用此宏定义的
// 符号视为是被导出的。
#ifdef PROOFDLL_EXPORTS
#define PROOFDLL_API __declspec(dllexport)
#else
#define PROOFDLL_API __declspec(dllimport)
#endif
enum PROOF_LEVEL
{
	PROOF_NONE = 0,
	PROOF_BASIC = 1 << 0,
	PROOF_MIDDLE = 1 << 1,
	PROOF_HIGH = 1 << 2
};

struct CHAR_BUFFER
{
	char* buffer;
	UINT  size;
};

PROOFDLL_API UINT getProofLevel();
PROOFDLL_API int getErrorCode();
PROOFDLL_API void addUintParam(LPCWSTR strKey, UINT value);
PROOFDLL_API void addBoolParam(LPCWSTR strKey, BOOL value);
PROOFDLL_API void addBufferParam(LPCWSTR strKey, CHAR_BUFFER value);
PROOFDLL_API void addStringParam(LPCWSTR strKey, LPCWSTR value);
PROOFDLL_API BOOL doBasicEncrypt(CHAR_BUFFER outBuffer);
PROOFDLL_API BOOL doMiddleEncrypt(CHAR_BUFFER outBuffer);
PROOFDLL_API BOOL doHighEncrypt(CHAR_BUFFER outBuffer);

